(* TBTree13             Copyright (c)  1988            Dean H. Farwell II    *)

unit FileDecs;

(*****************************************************************************)
(*                                                                           *)
(*                     F I L E   D E C L A R A T I O N S                     *)
(*                                                                           *)
(*****************************************************************************)


(* This unit is required because these declarations are needed by both
   the Files unit and the Page unit.  They logically belong in the File unit
   but putting them there means that the File unit can not depend on the
   Page unit which it does.  In other words, separately declaring this
   info alleviates the recursive unit dependency problem which would occur.  *)

(* Version Information

   Version 1.1 - No Changes

   Version 1.2 - No Changes

   Version 1.3 - No Changes                                                  *)


(*////////////////////////// I N T E R F A C E //////////////////////////////*)

interface

const
    FNSIZE = 80;                (* Max number of characters in a file name.
                                   80 characters is used since a file name
                                   may consist of a drive specifier and/or
                                   directory info along with the actual
                                   name

                                   for example -
                                              A:\mydir\thisdir\xxxxxxxx.yyy  *)


    RNSIZE = 4;                 (* bytes required to store a record number *)

type
    FileTypes = (BITMAP,INDEX,DATA,LLIST);

    FnString = String[FnSize];      (* See FNSIZE definition above for an
                                       example of a file name                *)

    RecordNumber = -1 .. MAXLONGINT;       (* range of record numbers
                                              -1 used for error or unusual
                                              conditions                   *)

    PrNumber = RecordNumber;   (* Physical Record Number within a file     *)
    LrNumber = RecordNumber;   (* Logical Record Number within a file      *)
                               (* For both of the above type definitions
                                  -1 is used to account for error or
                                  unusual conditions                       *)

(*///////////////////// I M P L E M E N T A T I O N /////////////////////////*)

implementation


end.                                                 (* end of FileDecs unit *)
